]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
tests/smime: Use gpgsm instead of openssl for mml creation of S/MIME msgs
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For emacsclient
108 unset ALTERNATE_EDITOR
109
110 add_gnupg_home ()
111 {
112     local output
113     [ -d ${GNUPGHOME} ] && return
114     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
115     at_exit_function _gnupg_exit
116     mkdir -m 0700 "$GNUPGHOME"
117     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
118     test_debug "cat $GNUPGHOME/import.log"
119     if (gpg --quick-random --version >/dev/null 2>&1) ; then
120         echo quick-random >> "$GNUPGHOME"/gpg.conf
121     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
122         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
123     fi
124     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
125
126     # Change this if we ship a new test key
127     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
128     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
129     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
130 }
131
132 add_gpgsm_home ()
133 {
134     local fpr
135     [ -d "$GNUPGHOME" ] && return
136     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
137     at_exit_function _gnupg_exit
138     mkdir -m 0700 "$GNUPGHOME"
139     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
140         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
141         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
142               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
143     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
144     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
145     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
146     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
147     echo include-certs::1 | gpgconf --output /dev/null --change-options gpgsm
148     test_debug "cat $GNUPGHOME/import.log"
149 }
150
151 # Each test should start with something like this, after copyright notices:
152 #
153 # test_description='Description of this test...
154 # This test checks if command xyzzy does the right thing...
155 # '
156 # . ./test-lib.sh || exit 1
157
158 color=maybe
159
160 while test "$#" -ne 0
161 do
162         case "$1" in
163         -d|--debug)
164                 debug=t; shift ;;
165         -i|--immediate)
166                 immediate=t; shift ;;
167         -h|--help)
168                 help=t; shift ;;
169         -v|--verbose)
170                 verbose=t; shift ;;
171         -q|--quiet)
172                 quiet=t; shift ;;
173         --with-dashes)
174                 with_dashes=t; shift ;;
175         --no-color)
176                 color=; shift ;;
177         --no-python)
178                 # noop now...
179                 shift ;;
180         --valgrind)
181                 valgrind=t; verbose=t; shift ;;
182         --tee)
183                 shift ;; # was handled already
184         *)
185                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
186         esac
187 done
188
189 if test -n "$debug"; then
190     print_subtest () {
191         printf " %-4s" "[$((test_count - 1))]"
192     }
193 else
194     print_subtest () {
195         true
196     }
197 fi
198
199 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
200
201 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
202                 TERM=$ORIGINAL_TERM &&
203                 export TERM &&
204                 tput bold
205                 tput setaf
206                 tput sgr0
207         ) >/dev/null 2>&1
208 then
209         color=t
210 else
211         color=
212 fi
213
214 if test -n "$color"; then
215         say_color () {
216                 (
217                 TERM=$ORIGINAL_TERM
218                 export TERM
219                 case "$1" in
220                         error) tput bold; tput setaf 1;; # bold red
221                         skip)  tput bold; tput setaf 2;; # bold green
222                         pass)  tput setaf 2;;            # green
223                         info)  tput setaf 3;;            # brown
224                         *) test -n "$quiet" && return;;
225                 esac
226                 shift
227                 printf " "
228                 printf "$@"
229                 tput sgr0
230                 print_subtest
231                 )
232         }
233 else
234         say_color() {
235                 test -z "$1" && test -n "$quiet" && return
236                 shift
237                 printf " "
238                 printf "$@"
239                 print_subtest
240         }
241 fi
242
243 error () {
244         say_color error "error: $*\n"
245         GIT_EXIT_OK=t
246         exit 1
247 }
248
249 say () {
250         say_color info "$*"
251 }
252
253 test "${test_description}" != "" ||
254 error "Test script did not set test_description."
255
256 if test "$help" = "t"
257 then
258         echo "Tests ${test_description}"
259         exit 0
260 fi
261
262 test_description_printed=
263 print_test_description ()
264 {
265         test -z "$test_description_printed" || return 0
266         echo
267         echo $this_test: "Testing ${test_description}"
268         test_description_printed=1
269 }
270 if [ -z "$NOTMUCH_TEST_QUIET" ]
271 then
272         print_test_description
273 fi
274
275 test_failure=0
276 test_count=0
277 test_fixed=0
278 test_broken=0
279 test_success=0
280
281 declare -a _exit_functions=()
282
283 at_exit_function () {
284         _exit_functions=($1 ${_exit_functions[@]/$1})
285 }
286
287 rm_exit_function () {
288         _exit_functions=(${_exit_functions[@]/$1})
289 }
290
291 _exit_common () {
292         code=$?
293         trap - EXIT
294         set +ex
295         for _fn in ${_exit_functions[@]}; do $_fn; done
296         rm -rf "$TEST_TMPDIR"
297 }
298
299 trap_exit () {
300         _exit_common
301         if test -n "$GIT_EXIT_OK"
302         then
303                 exit $code
304         else
305                 exec >&6
306                 say_color error '%-6s' FATAL
307                 echo " $test_subtest_name"
308                 echo
309                 echo "Unexpected exit while executing $0. Exit code $code."
310                 exit 1
311         fi
312 }
313
314 trap_signal () {
315         _exit_common
316         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
317         exit $code
318 }
319
320 die () {
321         _exit_common
322         exec >&6
323         say_color error '%-6s' FATAL
324         echo " $*"
325         echo
326         echo "Unexpected exit while executing $0."
327         exit 1
328 }
329
330 GIT_EXIT_OK=
331 # Note: TEST_TMPDIR *NOT* exported!
332 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
333 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
334 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
335 trap 'trap_exit' EXIT
336 trap 'trap_signal' HUP INT TERM
337
338 # Deliver a message with emacs and add it to the database
339 #
340 # Uses emacs to generate and deliver a message to the mail store.
341 # Accepts arbitrary extra emacs/elisp functions to modify the message
342 # before sending, which is useful to doing things like attaching files
343 # to the message and encrypting/signing.
344 emacs_deliver_message ()
345 {
346     local subject="$1"
347     local body="$2"
348     shift 2
349     # before we can send a message, we have to prepare the FCC maildir
350     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
351     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
352     local smtp_dummy_pid= smtp_dummy_port=
353     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
354     test -n "$smtp_dummy_pid" || return 1
355     test -n "$smtp_dummy_port" || return 1
356
357     test_emacs \
358         "(let ((message-send-mail-function 'message-smtpmail-send-it)
359                (mail-host-address \"example.com\")
360                (smtpmail-smtp-server \"localhost\")
361                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
362            (notmuch-mua-mail)
363            (message-goto-to)
364            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
365            (message-goto-subject)
366            (insert \"${subject}\")
367            (message-goto-body)
368            (insert \"${body}\")
369            $*
370            (notmuch-mua-send-and-exit))"
371
372     # In case message was sent properly, client waits for confirmation
373     # before exiting and resuming control here; therefore making sure
374     # that server exits by sending (KILL) signal to it is safe.
375     kill -9 $smtp_dummy_pid
376     notmuch new >/dev/null
377 }
378
379 # Pretend to deliver a message with emacs. Really save it to a file
380 # and add it to the database
381 #
382 # Uses emacs to generate and deliver a message to the mail store.
383 # Accepts arbitrary extra emacs/elisp functions to modify the message
384 # before sending, which is useful to doing things like attaching files
385 # to the message and encrypting/signing.
386 #
387 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
388 # at the head of the argument list, they are sent directly to "notmuch
389 # new" after message delivery
390 emacs_fcc_message ()
391 {
392     local nmn_args=''
393     while [[ "$1" =~ ^-- ]]; do
394         nmn_args="$nmn_args $1"
395         shift
396     done
397     local subject="$1"
398     local body="$2"
399     shift 2
400     # before we can send a message, we have to prepare the FCC maildir
401     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
402
403     test_emacs \
404         "(let ((message-send-mail-function (lambda () t))
405                (mail-host-address \"example.com\"))
406            (notmuch-mua-mail)
407            (message-goto-to)
408            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
409            (message-goto-subject)
410            (insert \"${subject}\")
411            (message-goto-body)
412            (insert \"${body}\")
413            $*
414            (notmuch-mua-send-and-exit))" || return 1
415     notmuch new $nmn_args >/dev/null
416 }
417
418 # Add an existing, fixed corpus of email to the database.
419 #
420 # $1 is the corpus dir under corpora to add, using "default" if unset.
421 #
422 # The default corpus is based on about 50 messages from early in the
423 # history of the notmuch mailing list, which allows for reliably
424 # testing commands that need to operate on a not-totally-trivial
425 # number of messages.
426 add_email_corpus ()
427 {
428     corpus=${1:-default}
429
430     rm -rf ${MAIL_DIR}
431     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
432     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
433 }
434
435 test_begin_subtest ()
436 {
437     if [ -n "$inside_subtest" ]; then
438         exec 1>&6 2>&7          # Restore stdout and stderr
439         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
440     fi
441     test_subtest_name="$1"
442     test_reset_state_
443     # Redirect test output to the previously prepared file descriptors
444     # 3 and 4 (see below)
445     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
446     exec >&3 2>&4
447     inside_subtest=t
448 }
449
450 # Pass test if two arguments match
451 #
452 # Note: Unlike all other test_expect_* functions, this function does
453 # not accept a test name. Instead, the caller should call
454 # test_begin_subtest before calling this function in order to set the
455 # name.
456 test_expect_equal ()
457 {
458         exec 1>&6 2>&7          # Restore stdout and stderr
459         if [ -z "$inside_subtest" ]; then
460                 error "bug in the test script: test_expect_equal without test_begin_subtest"
461         fi
462         inside_subtest=
463         test "$#" = 2 ||
464         error "bug in the test script: not 2 parameters to test_expect_equal"
465
466         output="$1"
467         expected="$2"
468         if ! test_skip "$test_subtest_name"
469         then
470                 if [ "$output" = "$expected" ]; then
471                         test_ok_
472                 else
473                         testname=$this_test.$test_count
474                         echo "$expected" > $testname.expected
475                         echo "$output" > $testname.output
476                         test_failure_ "$(diff -u $testname.expected $testname.output)"
477                 fi
478     fi
479 }
480
481 # Like test_expect_equal, but takes two filenames.
482 test_expect_equal_file ()
483 {
484         exec 1>&6 2>&7          # Restore stdout and stderr
485         if [ -z "$inside_subtest" ]; then
486                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
487         fi
488         inside_subtest=
489         test "$#" = 2 ||
490         error "bug in the test script: not 2 parameters to test_expect_equal_file"
491
492         file1="$1"
493         file2="$2"
494         if ! test_skip "$test_subtest_name"
495         then
496                 if diff -q "$file1" "$file2" >/dev/null ; then
497                         test_ok_
498                 else
499                         testname=$this_test.$test_count
500                         basename1=`basename "$file1"`
501                         basename2=`basename "$file2"`
502                         cp "$file1" "$testname.$basename1"
503                         cp "$file2" "$testname.$basename2"
504                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
505                 fi
506     fi
507 }
508
509 # Like test_expect_equal, but arguments are JSON expressions to be
510 # canonicalized before diff'ing.  If an argument cannot be parsed, it
511 # is used unchanged so that there's something to diff against.
512 test_expect_equal_json () {
513     # The test suite forces LC_ALL=C, but this causes Python 3 to
514     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
515     # override Python's stdio encoding defaults.
516     local script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
517     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
518         || echo "$1")
519     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
520         || echo "$2")
521     shift 2
522     test_expect_equal "$output" "$expected" "$@"
523 }
524
525 # Sort the top-level list of JSON data from stdin.
526 test_sort_json () {
527     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
528         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
529 }
530
531 # test for json objects:
532 # read the source of test/json_check_nodes.py (or the output when
533 # invoking it without arguments) for an explanation of the syntax.
534 test_json_nodes () {
535         exec 1>&6 2>&7          # Restore stdout and stderr
536         if [ -z "$inside_subtest" ]; then
537                 error "bug in the test script: test_json_eval without test_begin_subtest"
538         fi
539         inside_subtest=
540         test "$#" > 0 ||
541             error "bug in the test script: test_json_nodes needs at least 1 parameter"
542
543         if ! test_skip "$test_subtest_name"
544         then
545             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON "$TEST_DIRECTORY"/json_check_nodes.py "$@")
546                 if [ "$?" = 0 ]
547                 then
548                         test_ok_
549                 else
550                         test_failure_ "$output"
551                 fi
552         fi
553 }
554
555 test_emacs_expect_t () {
556         test "$#" = 1 ||
557         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
558         if [ -z "$inside_subtest" ]; then
559                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
560         fi
561
562         # Run the test.
563         if ! test_skip "$test_subtest_name"
564         then
565                 test_emacs "(notmuch-test-run $1)" >/dev/null
566
567                 # Restore state after the test.
568                 exec 1>&6 2>&7          # Restore stdout and stderr
569                 inside_subtest=
570
571                 # Report success/failure.
572                 result=$(cat OUTPUT)
573                 if [ "$result" = t ]
574                 then
575                         test_ok_
576                 else
577                         test_failure_ "${result}"
578                 fi
579         else
580                 # Restore state after the (non) test.
581                 exec 1>&6 2>&7          # Restore stdout and stderr
582                 inside_subtest=
583         fi
584 }
585
586 NOTMUCH_NEW ()
587 {
588     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
589 }
590
591 NOTMUCH_DUMP_TAGS ()
592 {
593     # this relies on the default format being batch-tag, otherwise some tests will break
594     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
595 }
596
597 notmuch_drop_mail_headers ()
598 {
599     $NOTMUCH_PYTHON -c '
600 import email, sys
601 msg = email.message_from_file(sys.stdin)
602 for hdr in sys.argv[1:]: del msg[hdr]
603 print(msg.as_string(False))
604 ' "$@"
605 }
606
607 notmuch_search_sanitize ()
608 {
609     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
610 }
611
612 notmuch_search_files_sanitize ()
613 {
614     notmuch_dir_sanitize
615 }
616
617 notmuch_dir_sanitize ()
618 {
619     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
620 }
621
622 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
623 notmuch_show_sanitize ()
624 {
625     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
626 }
627 notmuch_show_sanitize_all ()
628 {
629     sed \
630         -e 's| filename:.*| filename:XXXXX|' \
631         -e 's| id:[^ ]* | id:XXXXX |' | \
632         notmuch_date_sanitize
633 }
634
635 notmuch_json_show_sanitize ()
636 {
637     sed \
638         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
639         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
640         -e 's|"filename": "signature.asc",||g' \
641         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
642         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
643         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
644 }
645
646 notmuch_emacs_error_sanitize ()
647 {
648     local command=$1
649     shift
650     for file in "$@"; do
651         echo "=== $file ==="
652         cat "$file"
653     done | sed  \
654         -e 's/^\[.*\]$/[XXX]/' \
655         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
656 }
657
658 notmuch_date_sanitize ()
659 {
660     sed \
661         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
662 }
663
664 notmuch_uuid_sanitize ()
665 {
666     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
667 }
668
669 notmuch_built_with_sanitize ()
670 {
671     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
672 }
673
674 notmuch_config_sanitize ()
675 {
676     notmuch_dir_sanitize | notmuch_built_with_sanitize
677 }
678
679 notmuch_show_part ()
680 {
681     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
682 }
683
684 # End of notmuch helper functions
685
686 # Use test_set_prereq to tell that a particular prerequisite is available.
687 #
688 # The prerequisite can later be checked for by using test_have_prereq.
689 #
690 # The single parameter is the prerequisite tag (a simple word, in all
691 # capital letters by convention).
692
693 test_set_prereq () {
694         satisfied="$satisfied$1 "
695 }
696 satisfied=" "
697
698 test_have_prereq () {
699         case $satisfied in
700         *" $1 "*)
701                 : yes, have it ;;
702         *)
703                 ! : nope ;;
704         esac
705 }
706
707 declare -A test_missing_external_prereq_
708 declare -A test_subtest_missing_external_prereq_
709
710 # declare prerequisite for the given external binary
711 test_declare_external_prereq () {
712         binary="$1"
713         test "$#" = 2 && name=$2 || name="$binary(1)"
714
715         if ! hash $binary 2>/dev/null; then
716                 test_missing_external_prereq_["${binary}"]=t
717                 eval "
718 $binary () {
719         test_subtest_missing_external_prereq_[\"${name}\"]=t
720         false
721 }"
722         fi
723 }
724
725 # Explicitly require external prerequisite.  Useful when binary is
726 # called indirectly (e.g. from emacs).
727 # Returns success if dependency is available, failure otherwise.
728 test_require_external_prereq () {
729         binary="$1"
730         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
731                 # dependency is missing, call the replacement function to note it
732                 eval "$binary"
733         else
734                 true
735         fi
736 }
737
738 # You are not expected to call test_ok_ and test_failure_ directly, use
739 # the text_expect_* functions instead.
740
741 test_ok_ () {
742         if test "$test_subtest_known_broken_" = "t"; then
743                 test_known_broken_ok_
744                 return
745         fi
746         test_success=$(($test_success + 1))
747         if test -n "$NOTMUCH_TEST_QUIET"; then
748                 return 0
749         fi
750         say_color pass "%-6s" "PASS"
751         echo " $test_subtest_name"
752 }
753
754 test_failure_ () {
755         print_test_description
756         if test "$test_subtest_known_broken_" = "t"; then
757                 test_known_broken_failure_ "$@"
758                 return
759         fi
760         test_failure=$(($test_failure + 1))
761         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
762         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
763         return 1
764 }
765
766 test_failure_message_ () {
767         say_color error "%-6s" "$1"
768         echo " $2"
769         shift 2
770         if [ "$#" != "0" ]; then
771                 echo "$@" | sed -e 's/^/        /'
772         fi
773         if test "$verbose" != "t"; then cat test.output; fi
774 }
775
776 test_known_broken_ok_ () {
777         test_reset_state_
778         test_fixed=$(($test_fixed+1))
779         say_color pass "%-6s" "FIXED"
780         echo " $test_subtest_name"
781 }
782
783 test_known_broken_failure_ () {
784         test_reset_state_
785         test_broken=$(($test_broken+1))
786         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
787                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
788         else
789                 test_failure_message_ "BROKEN" "$test_subtest_name"
790         fi
791         return 1
792 }
793
794 test_debug () {
795         test "$debug" = "" || eval "$1"
796 }
797
798 test_run_ () {
799         test_cleanup=:
800         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
801         eval >&3 2>&4 "$1"
802         eval_ret=$?
803         eval >&3 2>&4 "$test_cleanup"
804         return 0
805 }
806
807 test_skip () {
808         test_count=$(($test_count+1))
809         to_skip=
810         for skp in $NOTMUCH_SKIP_TESTS
811         do
812                 case $this_test.$test_count in
813                 $skp)
814                         to_skip=t
815                         break
816                 esac
817                 case $this_test_bare.$test_count in
818                 $skp)
819                         to_skip=t
820                         break
821                 esac
822         done
823         case "$to_skip" in
824         t)
825                 test_report_skip_ "$@"
826                 ;;
827         *)
828                 test_check_missing_external_prereqs_ "$@"
829                 ;;
830         esac
831 }
832
833 test_check_missing_external_prereqs_ () {
834         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
835                 say_color skip >&1 "missing prerequisites: "
836                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
837                 test_report_skip_ "$@"
838         else
839                 false
840         fi
841 }
842
843 test_report_skip_ () {
844         test_reset_state_
845         say_color skip >&3 "skipping test:"
846         echo " $@" >&3
847         say_color skip "%-6s" "SKIP"
848         echo " $1"
849 }
850
851 test_subtest_known_broken () {
852         test_subtest_known_broken_=t
853 }
854
855 test_expect_success () {
856         exec 1>&6 2>&7          # Restore stdout and stderr
857         if [ -z "$inside_subtest" ]; then
858                 error "bug in the test script: test_expect_success without test_begin_subtest"
859         fi
860         inside_subtest=
861         test "$#" = 1 ||
862         error "bug in the test script: not 1 parameters to test_expect_success"
863
864         if ! test_skip "$test_subtest_name"
865         then
866                 test_run_ "$1"
867                 run_ret="$?"
868                 # test_run_ may update missing external prerequisites
869                 test_check_missing_external_prereqs_ "$@" ||
870                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
871                 then
872                         test_ok_
873                 else
874                         test_failure_ "$1"
875                 fi
876         fi
877 }
878
879 test_expect_code () {
880         exec 1>&6 2>&7          # Restore stdout and stderr
881         if [ -z "$inside_subtest" ]; then
882                 error "bug in the test script: test_expect_code without test_begin_subtest"
883         fi
884         inside_subtest=
885         test "$#" = 2 ||
886         error "bug in the test script: not 2 parameters to test_expect_code"
887
888         if ! test_skip "$test_subtest_name"
889         then
890                 test_run_ "$2"
891                 run_ret="$?"
892                 # test_run_ may update missing external prerequisites,
893                 test_check_missing_external_prereqs_ "$@" ||
894                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
895                 then
896                         test_ok_
897                 else
898                         test_failure_ "exit code $eval_ret, expected $1" "$2"
899                 fi
900         fi
901 }
902
903 # This is not among top-level (test_expect_success)
904 # but is a prefix that can be used in the test script, like:
905 #
906 #       test_expect_success 'complain and die' '
907 #           do something &&
908 #           do something else &&
909 #           test_must_fail git checkout ../outerspace
910 #       '
911 #
912 # Writing this as "! git checkout ../outerspace" is wrong, because
913 # the failure could be due to a segv.  We want a controlled failure.
914
915 test_must_fail () {
916         "$@"
917         test $? -gt 0 -a $? -le 129 -o $? -gt 192
918 }
919
920 # test_cmp is a helper function to compare actual and expected output.
921 # You can use it like:
922 #
923 #       test_expect_success 'foo works' '
924 #               echo expected >expected &&
925 #               foo >actual &&
926 #               test_cmp expected actual
927 #       '
928 #
929 # This could be written as either "cmp" or "diff -u", but:
930 # - cmp's output is not nearly as easy to read as diff -u
931 # - not all diff versions understand "-u"
932
933 test_cmp() {
934         $GIT_TEST_CMP "$@"
935 }
936
937 # This function can be used to schedule some commands to be run
938 # unconditionally at the end of the test to restore sanity:
939 #
940 #       test_expect_success 'test core.capslock' '
941 #               git config core.capslock true &&
942 #               test_when_finished "git config --unset core.capslock" &&
943 #               hello world
944 #       '
945 #
946 # That would be roughly equivalent to
947 #
948 #       test_expect_success 'test core.capslock' '
949 #               git config core.capslock true &&
950 #               hello world
951 #               git config --unset core.capslock
952 #       '
953 #
954 # except that the greeting and config --unset must both succeed for
955 # the test to pass.
956
957 test_when_finished () {
958         test_cleanup="{ $*
959                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
960 }
961
962 test_done () {
963         GIT_EXIT_OK=t
964         test_results_dir="$TEST_DIRECTORY/test-results"
965         mkdir -p "$test_results_dir"
966         test_results_path="$test_results_dir/$this_test"
967
968         echo "total $test_count" >> $test_results_path
969         echo "success $test_success" >> $test_results_path
970         echo "fixed $test_fixed" >> $test_results_path
971         echo "broken $test_broken" >> $test_results_path
972         echo "failed $test_failure" >> $test_results_path
973         echo "" >> $test_results_path
974
975         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
976
977         if [ "$test_failure" = "0" ]; then
978             if [ "$test_broken" = "0" ]; then
979                 rm -rf "$remove_tmp"
980             fi
981             exit 0
982         else
983             exit 1
984         fi
985 }
986
987 emacs_generate_script () {
988         # Construct a little test script here for the benefit of the user,
989         # (who can easily run "run_emacs" to get the same emacs environment
990         # for investigating any failures).
991         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
992 #!/bin/sh
993 export PATH=$PATH
994 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
995
996 # Here's what we are using here:
997 #
998 # --quick              Use minimal customization. This implies --no-init-file,
999 #                      --no-site-file and (emacs 24) --no-site-lisp
1000 #
1001 # --directory           Ensure that the local elisp sources are found
1002 #
1003 # --load                Force loading of notmuch.el and test-lib.el
1004
1005 exec ${TEST_EMACS} --quick \
1006         --directory "$NOTMUCH_SRCDIR/emacs" --load notmuch.el \
1007         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
1008         "\$@"
1009 EOF
1010         chmod a+x "$TMP_DIRECTORY/run_emacs"
1011 }
1012
1013 test_emacs () {
1014         # test dependencies beforehand to avoid the waiting loop below
1015         missing_dependencies=
1016         test_require_external_prereq dtach || missing_dependencies=1
1017         test_require_external_prereq emacs || missing_dependencies=1
1018         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1019         test -z "$missing_dependencies" || return
1020
1021         if [ -z "$EMACS_SERVER" ]; then
1022                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1023                 if [ -f "$emacs_tests" ]; then
1024                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1025                 else
1026                         load_emacs_tests=
1027                 fi
1028                 server_name="notmuch-test-suite-$$"
1029                 # start a detached session with an emacs server
1030                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1031                 # or unknown) is given to dtach which assumes a minimally
1032                 # VT100-compatible terminal -- and emacs inherits that
1033                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1034                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1035                                 --no-window-system \
1036                                 $load_emacs_tests \
1037                                 --eval '(setq server-name \"$server_name\")' \
1038                                 --eval '(server-start)' \
1039                                 --eval '(orphan-watchdog $$)'" || return
1040                 EMACS_SERVER="$server_name"
1041                 # wait until the emacs server is up
1042                 until test_emacs '()' >/dev/null 2>/dev/null; do
1043                         sleep 1
1044                 done
1045         fi
1046
1047         # Clear test-output output file.  Most Emacs tests end with a
1048         # call to (test-output).  If the test code fails with an
1049         # exception before this call, the output file won't get
1050         # updated.  Since we don't want to compare against an output
1051         # file from another test, so start out with an empty file.
1052         rm -f OUTPUT
1053         touch OUTPUT
1054
1055         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1056 }
1057
1058 test_python() {
1059     # Note: if there is need to print debug information from python program,
1060     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1061     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1062         $NOTMUCH_PYTHON -B - > OUTPUT
1063 }
1064
1065 test_ruby() {
1066     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I $NOTMUCH_SRCDIR/bindings/ruby> OUTPUT
1067 }
1068
1069 test_C () {
1070     exec_file="test${test_count}"
1071     test_file="${exec_file}.c"
1072     cat > ${test_file}
1073     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1074     echo "== stdout ==" > OUTPUT.stdout
1075     echo "== stderr ==" > OUTPUT.stderr
1076     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1077     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr > OUTPUT
1078 }
1079
1080 make_shim () {
1081     base_name="$1"
1082     test_file="${base_name}.c"
1083     shim_file="${base_name}.so"
1084     cat > ${test_file}
1085     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1086 }
1087
1088 notmuch_with_shim () {
1089     base_name="$1"
1090     shift
1091     shim_file="${base_name}.so"
1092     LD_PRELOAD=./${shim_file}${LD_PRELOAD:+:$LD_PRELOAD} notmuch-shared "$@"
1093 }
1094
1095 # Creates a script that counts how much time it is executed and calls
1096 # notmuch.  $notmuch_counter_command is set to the path to the
1097 # generated script.  Use notmuch_counter_value() function to get the
1098 # current counter value.
1099 notmuch_counter_reset () {
1100         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1101         if [ ! -x "$notmuch_counter_command" ]; then
1102                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1103                 cat >"$notmuch_counter_command" <<EOF || return
1104 #!/bin/sh
1105
1106 read count < "$notmuch_counter_state_path"
1107 echo \$((count + 1)) > "$notmuch_counter_state_path"
1108
1109 exec notmuch "\$@"
1110 EOF
1111                 chmod +x "$notmuch_counter_command" || return
1112         fi
1113
1114         echo 0 > "$notmuch_counter_state_path"
1115 }
1116
1117 # Returns the current notmuch counter value.
1118 notmuch_counter_value () {
1119         if [ -r "$notmuch_counter_state_path" ]; then
1120                 read count < "$notmuch_counter_state_path"
1121         else
1122                 count=0
1123         fi
1124         echo $count
1125 }
1126
1127 test_reset_state_ () {
1128         test -z "$test_init_done_" && test_init_
1129
1130         test_subtest_known_broken_=
1131         test_subtest_missing_external_prereq_=()
1132 }
1133
1134 # called once before the first subtest
1135 test_init_ () {
1136         test_init_done_=t
1137
1138         # skip all tests if there were external prerequisites missing during init
1139         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1140 }
1141
1142
1143 # Where to run the tests
1144 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1145
1146 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1147
1148 emacs_generate_script
1149
1150
1151 # Use -P to resolve symlinks in our working directory so that the cwd
1152 # in subprocesses like git equals our $PWD (for pathname comparisons).
1153 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1154
1155 if test "$verbose" = "t"
1156 then
1157         exec 4>&2 3>&1
1158 else
1159         exec 4>test.output 3>&4
1160 fi
1161
1162 for skp in $NOTMUCH_SKIP_TESTS
1163 do
1164         to_skip=
1165         for skp in $NOTMUCH_SKIP_TESTS
1166         do
1167                 case "$this_test" in
1168                 $skp)
1169                         to_skip=t
1170                         break
1171                 esac
1172                 case "$this_test_bare" in
1173                 $skp)
1174                         to_skip=t
1175                         break
1176                 esac
1177         done
1178         case "$to_skip" in
1179         t)
1180                 say_color skip >&3 "skipping test $this_test altogether"
1181                 say_color skip "skip all tests in $this_test"
1182                 test_done
1183         esac
1184 done
1185
1186 # Provide an implementation of the 'yes' utility
1187 yes () {
1188         if test $# = 0
1189         then
1190                 y=y
1191         else
1192                 y="$*"
1193         fi
1194
1195         while echo "$y"
1196         do
1197                 :
1198         done
1199 }
1200
1201 # Fix some commands on Windows
1202 case $(uname -s) in
1203 *MINGW*)
1204         # Windows has its own (incompatible) sort and find
1205         sort () {
1206                 /usr/bin/sort "$@"
1207         }
1208         find () {
1209                 /usr/bin/find "$@"
1210         }
1211         sum () {
1212                 md5sum "$@"
1213         }
1214         # git sees Windows-style pwd
1215         pwd () {
1216                 builtin pwd -W
1217         }
1218         # no POSIX permissions
1219         # backslashes in pathspec are converted to '/'
1220         # exec does not inherit the PID
1221         ;;
1222 *)
1223         test_set_prereq POSIXPERM
1224         test_set_prereq BSLASHPSPEC
1225         test_set_prereq EXECKEEPSPID
1226         ;;
1227 esac
1228
1229 test -z "$NO_PERL" && test_set_prereq PERL
1230 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1231
1232 # test whether the filesystem supports symbolic links
1233 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1234 rm -f y
1235
1236 # convert variable from configure to more convenient form
1237 case "$NOTMUCH_DEFAULT_XAPIAN_BACKEND" in
1238     glass)
1239         db_ending=glass
1240     ;;
1241     chert)
1242         db_ending=DB
1243     ;;
1244     *)
1245         error "Unknown Xapian backend $NOTMUCH_DEFAULT_XAPIAN_BACKEND"
1246 esac
1247 # declare prerequisites for external binaries used in tests
1248 test_declare_external_prereq dtach
1249 test_declare_external_prereq emacs
1250 test_declare_external_prereq ${TEST_EMACSCLIENT}
1251 test_declare_external_prereq ${TEST_GDB}
1252 test_declare_external_prereq gpg
1253 test_declare_external_prereq openssl
1254 test_declare_external_prereq gpgsm
1255 test_declare_external_prereq ${NOTMUCH_PYTHON}